#include "Assym.hpp"
#include "Logging.hpp"
#include <fstream>

const char*  assym_cpp_version(){return "$Revision: 1.15 $";}

using std::ofstream;


void Assym::undoAssCompl(){
	clearProp();
	undoAss();
}


void Assym::undoAss(){
	for(uint32_t i=0;i < ass_stck.size();++i){
		vals.varClearValue(ass_stck[i].toVar());
	}
	ass_stck.clear();
}

void Assym::clearProp(){
	prop_touched.clear();
	for(uint32_t i=prop_confl.size();i--;){
		clses.getECls(prop_confl[i]).setMrk(false);}
	prop_confl.clear();
	confl_strt = 0;
}


bool Assym::enqBcpBin(Literal tlit, const levl_t& reason, const levl_t& root){
	uint32_t bq			= ass_stck.size(); asrt(vals.litUkwn(tlit));
	enqueue(tlit,reason,root);asrt(vals.litTrue(tlit));
	Literal oth, flit;

	while(bq !=ass_stck.size()){
		tlit 			= ass_stck[bq++];
		flit 			= tlit.flipped();
		Iter<Literal> i	= clses.getBinsOf(flit);
		while(i.getNext(oth)){
			if(vals.litFalse(oth)){ 	return false;}

			if(vals.litUkwn(oth)){		enqueue(oth,reason,root);
			}else{						vInfP(oth)->root |= root;}

			prop_touched.push_back(std::make_pair<Literal,ClsWrp>(oth,ClsWrp(flit)));
		}
	}
	return true;
}


//lits are not initialised. Literals are copied from orig ot to lits array
Assym::Task Assym::enqFlippedLits(Literal* lits, uint32_t& sz, levl_t& all_lvls, const ECP& orig){
	levl_t levl = 1; sz=0; sanity(var_flgs.allCleared());
	//uint32_t max_mrk=0;

	ExtCls& ec 	= clses.getECls(orig);
	ec			.setMrk(true); asrt(!vals.litKnwn(ec.getLit()));
	lits[0]		= ec.getLit();
	sz			= 1;

	if(!enqBcpBin(lits[0].flipped(),levl,levl)){
			LOG1("Unit [0] found in enqFlipped " << lits[0].toDIMACS());
			units_out.push_back(lits[0]); return LEAVE;} asrt(vals.litFalse(lits[0]));

	all_lvls 	= levl; asrt(powOf2(vInfP(lits[0])->reasn));
	levl 		<<= 1;
	var_flgs	.setFlag(lits[0].toVar());
	Cls& cls	= glob.getCls(ec.getClp());
	lits[1]		= cls.otherWatcher(lits[0]);

	if(vals.litTrue(lits[1])){inc_stat(assym_subsum_easy,1);
		subsum_out.push_back(Subsumd(orig,ECP(max32))); return LEAVE;}

	if(vals.litFalse(lits[1])){ inc_stat(assym_shrnk_easy,1); //lit can be omitted
	}else{
		if(!enqBcpBin(lits[1].flipped(),levl,levl)){
			LOG1("Unit [1] found in enqFlipped " << lits[1].toDIMACS());
			units_out.push_back(lits[1]); return LEAVE;} asrt(vals.litFalse(lits[1]));

		var_flgs	.setFlag(lits[1].toVar()); asrt(powOf2(vInfP(lits[1])->reasn));
		all_lvls 	|= levl;
		levl 		<<= 1;
		sz			= 2;
	}

	ClsLit* clit	= cls.uwBeg();
	do{
		Literal cl(clit->lit);
		//lit can be omitted
		if(vals.litFalse(cl)){inc_stat(assym_shrnk_easy,1);	continue;}

		//clause is completely subsumed by binary (closure)
		if(vals.litTrue(cl)){ inc_stat(assym_subsum_easy,1);
			subsum_out.push_back(Subsumd(orig,ECP(max32)));	return LEAVE;}

		//propagate flipped literal
		if(levl && !enqBcpBin(cl.flipped(),levl,levl)){
			LOG1("Unit [i] found in enqFlipped " << cl.toDIMACS());
			units_out.push_back(cl); 						return LEAVE;}

		asrt(vals.litFalse(cl) || levl==0); asrt(levl==0 || powOf2(vInfP(cl)->reasn));
		var_flgs	.setFlag(cl.toVar());
		lits[sz++] 	= cl;
		all_lvls 	|= levl;
		levl 		<<= 1;
	}while((clit++)->has_next);

	asrt(levl || sz >= sizeof(levl_t)*8);
	return sz > (sizeof(levl_t)*8) ? TAKE_MRKD : GO;
}



Assym::Task Assym::propLongs(const Literal* lits){
	Literal oth,flit,tlit; levl_t reason,roots; EWtch ew(ClsP(0),ECP(0)); ClsLit* clit;

	for(uint32_t q=0; q!= ass_stck.size();++q){
		tlit			= ass_stck[q]; LOG2("Propagate lit " << tlit.toDIMACS());
		flit 			= tlit.flipped(); asrt(vals.litFalse(flit));
		WIter<EWtch> i	= wtching.getWIter(flit);

		while(i.getNext(ew)){

			if(clses.getECls(ew.extp).isMrkd()){i.keep(ew); 	continue;}

			Cls& cls	= glob.getCls(ew.clp);
			oth			= cls.otherWatcher(flit);

			if(vals.litTrue(oth)){
				if(var_flgs.isSet(oth.toVar())){ asrt(powOf2(vInfP(oth)->reasn));
					prop_touched.push_back(std::make_pair<Literal,ClsWrp>(oth,ClsWrp(ew.clp)));}
				i.keep(ew);										continue;}

			clit = cls.uwBeg();
			do{
				Literal cnd (clit->lit);
				if(!vals.litFalse(cnd)){
					cls.changeWatchers(oth,clit,flit);
					wtching.add(cnd,ew);
					clses.setLitFor(ew.extp,cnd);
					goto NEXT_CLS;
				}
			}while((clit++)->has_next);

			i.keep(ew);
			if(vals.litUkwn(oth)){
				collReasons(cls,oth,reason,roots);

				if(roots!=0){ addBins(oth,roots,lits);}
				asrt(!var_flgs.isSet(oth.toVar()));

				if(!enqBcpBin(oth,reason,roots)){
					LOG1("Unit found in propagation" << oth.flipped().toDIMACS());
					units_out.push_back(oth.flipped());
					while(i.getNext(ew)){i.keep(ew);}	wtching.finish(flit,i);
					return LEAVE;} asrt(vals.litTrue(oth));
			}else{
				prop_confl.push_back(ew.extp);
				clses	.getECls(ew.extp).setMrk(true);
			}
			NEXT_CLS:;
		}
		wtching.finish(flit,i);
	}
	return GO;
}




//returns max32 if nothing changed
//or number of marked variables in orig clause that shall be kept
uint32_t Assym::shrinkyWinky(const ECP& orig){
	asrt(units_out.empty()); asrt(clses.asrtNoMrkdClses());
	levl_t all_levls; uint32_t mrkd;	inc_stat(assym_clschk,1);

	ExtCls& ec 					= clses.getECls(orig); asrt(ec.shallAssymChd()); asrt(!ec.isWaste());
	const uint32_t alloc_sz 	= ec.size();
	Literal lits				[alloc_sz];

	T_ON(assymbcpbin);
	Task task		= enqFlippedLits(lits,mrkd,all_levls,orig); asrt(task != NEWVERSION);
	T_OFF(assymbcpbin);

	uint32_t end	= mrkd; asrt(end<=alloc_sz);
	if(task!=GO){	goto FINISH_CLS;}

	do{
		T_ON(assymbcp);
		task			= propLongs(lits); asrt(task != NEWVERSION);
		T_OFF(assymbcp);

		if(task!=GO){	goto FINISH_CLS;}

		T_ON(assymflscls);
		task			= handleConflictingFor(orig,lits,end,mrkd,all_levls); asrt(end<=alloc_sz);
		T_OFF(assymflscls);

	}while(task==NEWVERSION)	; asrt(mrkd<=end);

	if(task==GO){
		T_ON(assymtouchdcls);
		task			= smpleChk(mrkd,lits,end);
		T_OFF(assymtouchdcls);
	}

	FINISH_CLS:; asrt(mrkd<=end); asrt(task == LEAVE || task == TAKE_MRKD);
	undoAssCompl();
	clses.getECls(orig).setMrk(false); asrt(clses.asrtNoMrkdClses());

	if((task==TAKE_MRKD) && mrkd!=alloc_sz){
		inc_stat(assym_litsrem,(alloc_sz - mrkd)); asrt(mrkd>0);

		if(mrkd > 2) return mrkd;

		Literal res[mrkd]; uint32_t p=mrkd;
		for(uint32_t l=0;p;++l){ asrt(l<end);
			if(var_flgs.isSet(lits[l].toVar())){
				var_flgs	.clear(lits[l].toVar());
				res[--p] 	= lits[l];}
		}

		sanity(var_flgs.allCleared());


		if(mrkd==1){
			LOG1("Unit in shrinkyWinky: " << lits[0].toDIMACS());
			units_out.push_back(res[0]);
		}else{asrt(mrkd==2);
			LOG2("Binary in shrinkyWinky: " << lits[0].toDIMACS() << " , " << lits[1].toDIMACS());
			subsum_out.push_back(Subsumd(orig,ECP(max32)));
			clses.addBin(res[0],res[1]);
		}

		return max32;

	}

	for(mrkd=0;mrkd!=end;++mrkd){var_flgs.carelessClear(lits[mrkd].toVar());}
	return max32; //no direct change but maybe there are unit clauses or subsumed clauses
}



void Assym::collReasons(Cls& cls, const Literal& except_w, levl_t& reason, levl_t& root){
	VInf* vinf		= vInfP(cls.otherWatcher(except_w));
	reason			= vinf->reasn; asrt(vals.litFalse(cls.otherWatcher(except_w)));
	root			= vinf->root;  asrt(!var_flgs.isSet(cls.otherWatcher(except_w).toVar()) || powOf2(vinf->reasn));

	ClsLit* clit	= cls.uwBeg();
	do{
		VInf* vi	= vInfP(Literal(clit->lit));
		reason		|= vi->reasn; asrt(!var_flgs.isSet(Literal(clit->lit).toVar()) || powOf2(vi->reasn));
		root		&= vi->root;
	}while((clit++)->has_next);
}


uint32_t Assym::collRsnsCountMrkd(Cls& cls, const Literal& w, levl_t& reason, levl_t& root){
	Literal o 	= cls.otherWatcher(w); asrt(vals.litFalse(w)); asrt(vals.litFalse(o));
	VInf* wi	= vInfP(w); asrt(!var_flgs.isSet(w.toVar()) || powOf2(wi->reasn));
	VInf* oi	= vInfP(o); asrt(!var_flgs.isSet(o.toVar()) || powOf2(oi->reasn));
	reason 		= wi->reasn 	| oi->reasn;
	root 		= wi->root		& oi->root;
	uint32_t m 	= var_flgs.isSet(o.toVar()) + var_flgs.isSet(w.toVar());
	ClsLit* clit	= cls.uwBeg();

	do{
		Variable v 	= Literal(clit->lit).toVar(); asrt(vals.varKnwn(v));
		VInf* vi	= vInfP(v); asrt(!var_flgs.isSet(v) || powOf2(vi->reasn));
		reason		|= vi->reasn;
		root		&= vi->root;
		m			+= var_flgs.isSet(v);

	}while((clit++)->has_next);
	return m;
}

Assym::Task 	Assym::handleConflictingFor(const ECP& orig,Literal* lits, uint32_t& end, uint32_t& mrkd, levl_t& all_levs){
	levl_t reason,roots;
	levl_t min_reason = all_levs;
	uint8_t c_min_r	= count_ones.get64(min_reason); asrt (c_min_r<=end); asrt(confl_strt <= prop_confl.size());

	while(confl_strt<prop_confl.size()){
		ECP& ecp	= prop_confl[confl_strt++]; asrt(orig.idx != ecp.idx);
		ExtCls& ec	= clses.getECls(ecp); asrt(ec.isMrkd());
		Literal a 	= ec.getLit(); asrt(vals.litFalse(a));
		Cls& cls		= glob.getCls(ec.getClp());
		uint32_t m	= collRsnsCountMrkd(cls,a,reason,roots);

		if(roots){//conflict depends on at least one unit cls
			for(uint32_t i=0;roots;++i,roots>>=1){
				if(roots&1){ LOG1("Unit found by roots " << lits[1].toDIMACS());
					units_out.push_back(lits[i]); }
			}
			return LEAVE;
		}

		if(m==end){ //current cls is subsumed by orig
			subsum_out.push_back(Subsumd(ecp,orig));

		}else if(m == ec.size()){//all lits marked in cls -> cls subsumes orig

			subsum_out.push_back(Subsumd(orig,ecp));
			return LEAVE;
		}

		if(reason!=all_levs){ asrt((reason & ~all_levs) == 0); //conflict depends on subset of lits

			uint8_t invlvd	= count_ones.get64(reason);
			if(invlvd < c_min_r){c_min_r=invlvd; min_reason=reason;}
		}
	}

	if(min_reason == all_levs){ return GO;} //all conflicts depend on all lits

	//propagate the flipped lits of the new subclause again
	undoAss();
	prop_touched.clear(); asrt(end <= sizeof(levl_t)*8);
	mrkd = 0; levl_t levl = 1; all_levs = 0;

	for(uint32_t l=0;l!=end;++l,min_reason>>=1){
		Literal cl = lits[l]; var_flgs.clear(cl.toVar());

		//lit can be omitted
		if(vals.litFalse(cl)){inc_stat(assym_shrnk_easy,1);	continue;}

		//clause is completely subsumed by binary (closure)
		if(vals.litTrue(cl)){ inc_stat(assym_subsum_easy,1);
			subsum_out.push_back(Subsumd(orig,ECP(max32)));	return LEAVE;}


		asrt(vals.litUkwn(cl));
		if(min_reason&1){
			var_flgs.setFlag(cl.toVar()); //should be already set
			lits[mrkd++]=cl;

			if(levl && !enqBcpBin(cl.flipped(),levl,levl)){
				LOG1("Unit [i] found in re enqFlipped " << cl.toDIMACS());
				units_out.push_back(cl); 	return LEAVE;}

			all_levs 	|= levl;
			levl 		<<= 1;
		}
	} asrt(min_reason == 0);

	end = mrkd; LOG2("New version available");
	return NEWVERSION;
}


Assym::Task 	Assym::smpleChk(uint32_t& mrkd_c,const Literal* lits,const uint32_t& end){
	mrkd_c = end;
	if(mrkd_c <= 2) 	return TAKE_MRKD;

	levl_t rem_lev 	= 0;levl_t alt_reas,alt_roots; bool change;
	uint32_t nsz = prop_touched.size();

	do{
		change 				= false;
		const uint32_t sz 	= nsz;
		nsz					= 0;


		for(uint32_t t=0;t!= sz;++t){

			Literal lu		= prop_touched[t].first; asrt(vals.litTrue(lu));
			ClsWrp&	clw		= prop_touched[t].second;

			if(!getAltReason(lu,clw,alt_reas,alt_roots)) continue;

			VInf* ai		= vInfP(lu);
			addBins(lu,ai,alt_roots,lits);

			//var(lu) is not a variable of the remaining clause
			if(!var_flgs.isSet(lu.toVar())){			continue;}
			asrt(powOf2(ai->reasn)); 					//just itself is reason

			//check if there is an alternative valid binary reason
			levl_t binr = ai->root & ~(rem_lev | ai->reasn);
			if(binr){
				//next check will match since alt_reas is independent of lu
				for(alt_reas=1;(binr&alt_reas)==0;alt_reas<<=1){} asrt((ai->reasn & alt_reas) == 0);}

			if((ai->reasn & alt_reas) == 0){ //others are independent of lu
				var_flgs.clear(lu.toVar()); 	asrt((rem_lev & ai->reasn) ==0);
				rem_lev |= ai->reasn; 			asrt((rem_lev & alt_reas) ==0);
				change	= true;

				updateAllReasons(lits,end,ai->reasn,alt_reas);
				inc_stat(assym_shrnk_ana,1); asrt((ai->reasn & rem_lev) == 0);

				if(--mrkd_c <= 2){ return TAKE_MRKD;}
			}else{
				prop_touched[nsz++] = prop_touched[t];
			}
		}
	}while(change && glob.sets.assym_loop);

	return TAKE_MRKD;
}



bool	Assym::getAltReason(const Literal& l, const ClsWrp& clw,levl_t& reas_out, levl_t& root_out){ asrt(vals.litTrue(l));
	if(clw.isBin()){ asrt(vals.litFalse(clw.getLit()));
		VInf* ai 	= vInfP(clw.getLit());
		reas_out	= ai->reasn;
		root_out	= ai->root;
		return true;
	}

	Cls& cls		= glob.getCls(clw.getClp());
	VInf* ai		= vInfP(cls.otherWatcher(l));
	reas_out 		= ai->reasn; asrt(vals.litFalse(cls.otherWatcher(l)));
	root_out 		= ai->root;
	ClsLit* clit	= cls.uwBeg();
	do{
		Literal cnd(clit->lit);
		if(!vals.litFalse(cnd)) return false;
		VInf* aj	= vInfP(cnd);
		reas_out	|= aj->reasn;
		root_out	&= aj->root;
	}while((clit++)->has_next);

	return true;
}

void 	Assym::updateAllReasons(const Literal* lits, const uint32_t& end, const levl_t old, const levl_t repl){
	asrt(powOf2(old)); asrt((old&repl)==0);

	levl_t newl;
	for(uint32_t j=0;j!=end;++j){ asrt(vals.litFalse(lits[j]));
		VInf* ti		= vInfP(lits[j]);
		if(ti->reasn & old) {
			newl		= (ti->reasn & ~old) | repl;
			ti->reasn	= newl;
		}asrt((ti->reasn & old) == 0);
	}

	for(uint32_t i=0;i!=ass_stck.size();++i){
		VInf* ai	= vInfP(ass_stck[i]);
		if(ai->reasn & old) {
			newl		= (ai->reasn & ~old) | repl;
			ai->reasn	= newl;
		}asrt((ai->reasn & old) == 0);
	}
}

#ifdef ASSYM_HYPER_BIN
void Assym::addBins(const Literal& lit, levl_t roots, const Literal* lits){
	asrt(roots); asrt(!vals.litFalse(lit));
	//const bool add = act_hp.getValue(lit.toVar()) >= hbin_over;
	if(act_hp.getValue(lit.toVar()) < hbin_over) return;

	for(uint32_t i=0;roots;++i,roots>>=1){
		if((roots&1) && (act_hp.getValue(lits[i].toVar()) >= hbin_over)){
			LOG2("Binary in Assym by roots : " << lits[i].toDIMACS());
			clses.addBin(lits[i],lit); inc_stat(assym_dom,1);}
	}
}

void Assym::addBins(const Literal& lit, VInf* ai, levl_t roots, const Literal* lits){
	roots 	&= ~(ai->root); //are there new binaries
	if(roots){
		ai->root |= roots; //store new binary implications
		addBins(lit,roots,lits);
	}
}
#else
void Assym::addBins(const Literal& lit, levl_t roots, const Literal* lits){}
void Assym::addBins(const Literal& lit, VInf* ai, levl_t roots, const Literal* lits){}
#endif

/*void Assym::justHpyerBin(const vector<Literal>& units_in, vector<Literal>& units_out,  const Literal& root){
	for(;units_updated < units_in.size();++units_updated){
			vals.setValue(units_in[units_updated]);}
	asrt(units_out.empty()); asrt(vals.litUkwn(root)); asrt(prop_confl.empty());

	if(!enqBcpBin(root,1,1)){
		units_out.push_back(root.flipped());
	}else{
		vector<Literal> lits(1,root.flipped());
		Literal res 	= propOfLits(ClsP(),lits);
		if(Literal::nrmlLit(res)){
			units_out.push_back(res.flipped());}
		if(!prop_confl.empty()){
			units_out.push_back(root.flipped());}

	}

	undoAssigns();
}*/





